"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.message
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

class ProgressRequest(google.protobuf.message.Message):
    """
    The request data sent for querying the progress.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    INTERRUPT_FIELD_NUMBER: builtins.int
    interrupt: builtins.bool = ...
    """Flag whether to interrupt the operation or not."""

    def __init__(self,
        *,
        interrupt : builtins.bool = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["interrupt",b"interrupt"]) -> None: ...
global___ProgressRequest = ProgressRequest

class ProgressResponse(google.protobuf.message.Message):
    """
    The response data returned for reporting the progress.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    STATE_FIELD_NUMBER: builtins.int
    state: builtins.int = ...
    """The integer value within [0, 100] indicating the current progress state."""

    def __init__(self,
        *,
        state : builtins.int = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["state",b"state"]) -> None: ...
global___ProgressResponse = ProgressResponse

class SHA1(google.protobuf.message.Message):
    """
    SHA-1
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    HEX_DIGEST_FIELD_NUMBER: builtins.int
    hex_digest: typing.Text = ...
    """The SHA-1 hash value rendered as a hexadecimal number (40 digits long)."""

    def __init__(self,
        *,
        hex_digest : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["hex_digest",b"hex_digest"]) -> None: ...
global___SHA1 = SHA1

class FileInfo(google.protobuf.message.Message):
    """
    The meta-data of a file.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    NAME_FIELD_NUMBER: builtins.int
    SIZE_FIELD_NUMBER: builtins.int
    SHA1_FIELD_NUMBER: builtins.int
    name: typing.Text = ...
    """The file name."""

    size: builtins.int = ...
    """The total size of the file in bytes.
    Note that we use signed integers everywhere even if negative values
    are not allowed, because unsigned integers are not well-supported on
    all languages (e.g. Java, JavaScript, OpenAPI). See the Google API
    guide (https://cloud.google.com/apis/design/design_patterns#integer_types)
    for reference.
    """

    @property
    def sha1(self) -> global___SHA1:
        """The SHA-1 message digest (checksum) of the file."""
        pass
    def __init__(self,
        *,
        name : typing.Text = ...,
        size : builtins.int = ...,
        sha1 : typing.Optional[global___SHA1] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["sha1",b"sha1"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["name",b"name","sha1",b"sha1","size",b"size"]) -> None: ...
global___FileInfo = FileInfo

class FileChunk(google.protobuf.message.Message):
    """
    The file content split into chunks.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    OFFSET_FIELD_NUMBER: builtins.int
    DATA_FIELD_NUMBER: builtins.int
    offset: builtins.int = ...
    """The offset of this chunk."""

    data: builtins.bytes = ...
    """The data."""

    def __init__(self,
        *,
        offset : builtins.int = ...,
        data : builtins.bytes = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["data",b"data","offset",b"offset"]) -> None: ...
global___FileChunk = FileChunk

class UploadFileRequest(google.protobuf.message.Message):
    """
    The request data sent for a 'UploadFile' operation.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class Initialize(google.protobuf.message.Message):
        """
        The request data sent for initializing a 'UploadFile' operation.
        """
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        FILE_INFO_FIELD_NUMBER: builtins.int
        @property
        def file_info(self) -> global___FileInfo:
            """The meta-data about the file."""
            pass
        def __init__(self,
            *,
            file_info : typing.Optional[global___FileInfo] = ...,
            ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["file_info",b"file_info"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["file_info",b"file_info"]) -> None: ...

    class SendData(google.protobuf.message.Message):
        """
        The request data sent for sending a chunk of data for a 'UploadFile' operation.
        """
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        FILE_DATA_FIELD_NUMBER: builtins.int
        @property
        def file_data(self) -> global___FileChunk:
            """The file data."""
            pass
        def __init__(self,
            *,
            file_data : typing.Optional[global___FileChunk] = ...,
            ) -> None: ...
        def HasField(self, field_name: typing_extensions.Literal["file_data",b"file_data"]) -> builtins.bool: ...
        def ClearField(self, field_name: typing_extensions.Literal["file_data",b"file_data"]) -> None: ...

    class Finalize(google.protobuf.message.Message):
        """
        The request data sent for finalizing a 'UploadFile' operation.
        """
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        def __init__(self,
            ) -> None: ...

    PROGRESS_FIELD_NUMBER: builtins.int
    INITIALIZE_FIELD_NUMBER: builtins.int
    SEND_DATA_FIELD_NUMBER: builtins.int
    FINALIZE_FIELD_NUMBER: builtins.int
    @property
    def progress(self) -> global___ProgressRequest:
        """The progress request."""
        pass
    @property
    def initialize(self) -> global___UploadFileRequest.Initialize:
        """Step 1 (once): Initializes the 'UploadFile' operation."""
        pass
    @property
    def send_data(self) -> global___UploadFileRequest.SendData:
        """Step 2 (#>1): Sends the file data (need to be called multiple times until all data are sent)."""
        pass
    @property
    def finalize(self) -> global___UploadFileRequest.Finalize:
        """Step 3 (once): Finalizes the 'UploadFile' operation."""
        pass
    def __init__(self,
        *,
        progress : typing.Optional[global___ProgressRequest] = ...,
        initialize : typing.Optional[global___UploadFileRequest.Initialize] = ...,
        send_data : typing.Optional[global___UploadFileRequest.SendData] = ...,
        finalize : typing.Optional[global___UploadFileRequest.Finalize] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["finalize",b"finalize","initialize",b"initialize","progress",b"progress","send_data",b"send_data","sub_step",b"sub_step"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["finalize",b"finalize","initialize",b"initialize","progress",b"progress","send_data",b"send_data","sub_step",b"sub_step"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["sub_step",b"sub_step"]) -> typing.Optional[typing_extensions.Literal["initialize","send_data","finalize"]]: ...
global___UploadFileRequest = UploadFileRequest

class UploadFileResponse(google.protobuf.message.Message):
    """
    The response data returned from a 'UploadFile' operation.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    PROGRESS_FIELD_NUMBER: builtins.int
    @property
    def progress(self) -> global___ProgressResponse:
        """The progress response"""
        pass
    def __init__(self,
        *,
        progress : typing.Optional[global___ProgressResponse] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["progress",b"progress"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["progress",b"progress"]) -> None: ...
global___UploadFileResponse = UploadFileResponse

class DownloadFileRequest(google.protobuf.message.Message):
    """
    The request data sent for a 'DownloadFile' operation.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    class Initialize(google.protobuf.message.Message):
        """
        The request data sent for initializing a 'DownloadFile' operation.
        """
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        FILENAME_FIELD_NUMBER: builtins.int
        CHUNK_SIZE_FIELD_NUMBER: builtins.int
        COMPUTE_SHA1_CHECKSUM_FIELD_NUMBER: builtins.int
        filename: typing.Text = ...
        """The name of the file to be used."""

        chunk_size: builtins.int = ...
        """The chunk size to be used for receiving the file data."""

        compute_sha1_checksum: builtins.bool = ...
        """Flag whether to compute the SHA-1 checksum of the file or not."""

        def __init__(self,
            *,
            filename : typing.Text = ...,
            chunk_size : builtins.int = ...,
            compute_sha1_checksum : builtins.bool = ...,
            ) -> None: ...
        def ClearField(self, field_name: typing_extensions.Literal["chunk_size",b"chunk_size","compute_sha1_checksum",b"compute_sha1_checksum","filename",b"filename"]) -> None: ...

    class ReceiveData(google.protobuf.message.Message):
        """
        The request data sent for receiving a chunk of data for a 'DownloadFile' operation.
        """
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        def __init__(self,
            ) -> None: ...

    class Finalize(google.protobuf.message.Message):
        """
        The request data sent for finalizing a 'DownloadFile' operation.
        """
        DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
        def __init__(self,
            ) -> None: ...

    PROGRESS_FIELD_NUMBER: builtins.int
    INITIALIZE_FIELD_NUMBER: builtins.int
    RECEIVE_DATA_FIELD_NUMBER: builtins.int
    FINALIZE_FIELD_NUMBER: builtins.int
    @property
    def progress(self) -> global___ProgressRequest:
        """The progress request."""
        pass
    @property
    def initialize(self) -> global___DownloadFileRequest.Initialize:
        """Step 1 (once): Initializes the 'DownloadFile' operation."""
        pass
    @property
    def receive_data(self) -> global___DownloadFileRequest.ReceiveData:
        """Step 2 (once): Initiates the receiving of the file data."""
        pass
    @property
    def finalize(self) -> global___DownloadFileRequest.Finalize:
        """Step 3 (once): Finalizes the 'DownloadFile' operation."""
        pass
    def __init__(self,
        *,
        progress : typing.Optional[global___ProgressRequest] = ...,
        initialize : typing.Optional[global___DownloadFileRequest.Initialize] = ...,
        receive_data : typing.Optional[global___DownloadFileRequest.ReceiveData] = ...,
        finalize : typing.Optional[global___DownloadFileRequest.Finalize] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["finalize",b"finalize","initialize",b"initialize","progress",b"progress","receive_data",b"receive_data","sub_step",b"sub_step"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["finalize",b"finalize","initialize",b"initialize","progress",b"progress","receive_data",b"receive_data","sub_step",b"sub_step"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["sub_step",b"sub_step"]) -> typing.Optional[typing_extensions.Literal["initialize","receive_data","finalize"]]: ...
global___DownloadFileRequest = DownloadFileRequest

class DownloadFileResponse(google.protobuf.message.Message):
    """
    The response data returned from a 'DownloadFile' operation.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    PROGRESS_FIELD_NUMBER: builtins.int
    FILE_INFO_FIELD_NUMBER: builtins.int
    FILE_DATA_FIELD_NUMBER: builtins.int
    @property
    def progress(self) -> global___ProgressResponse:
        """The progress response"""
        pass
    @property
    def file_info(self) -> global___FileInfo:
        """Step 1 (once): The meta-data about the file."""
        pass
    @property
    def file_data(self) -> global___FileChunk:
        """Step 2 (#>1): The file data."""
        pass
    def __init__(self,
        *,
        progress : typing.Optional[global___ProgressResponse] = ...,
        file_info : typing.Optional[global___FileInfo] = ...,
        file_data : typing.Optional[global___FileChunk] = ...,
        ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["file_data",b"file_data","file_info",b"file_info","progress",b"progress","sub_step",b"sub_step"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["file_data",b"file_data","file_info",b"file_info","progress",b"progress","sub_step",b"sub_step"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["sub_step",b"sub_step"]) -> typing.Optional[typing_extensions.Literal["file_info","file_data"]]: ...
global___DownloadFileResponse = DownloadFileResponse
